package xyz.lychee.lagfixer.libs.adventure.util;

import java.util.function.Consumer;
import xyz.lychee.lagfixer.libs.adventure.builder.AbstractBuilder;
import xyz.lychee.lagfixer.libs.annotations.Contract;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;

public interface Buildable<R, B extends Builder<R>> {
   /** @deprecated */
   @Deprecated
   @Contract(
      mutates = "param1"
   )
   static <R extends Buildable<R, B>, B extends Builder<R>> @NotNull R configureAndBuild(final @NotNull B builder, final @Nullable Consumer<? super B> consumer) {
      return (Buildable)AbstractBuilder.configureAndBuild(builder, consumer);
   }

   @Contract(
      value = "-> new",
      pure = true
   )
   @NotNull
   @NotNull B toBuilder();

   /** @deprecated */
   @Deprecated
   public interface Builder<R> extends AbstractBuilder<R> {
      @Contract(
         value = "-> new",
         pure = true
      )
      @NotNull R build();
   }
}
